\section{Simulation using CoppeliaSim}
\label{sec:simulator}

The software \href{https://www.coppeliarobotics.com/}{CoppeliaSim EDU} has been
used to simulate the manipulator movement and control in a simple scene. A
manipulator model has been assembled using simple shapes in order to optimize
the simulator performance. The mass of this shapes have been adjusted to
reasonable values, as well as the joint torques, but no further customization
has been applied to the dynamic model. A realistic simulation of the
manipulator is out of the scope of this project. It is in the scope the fact
that the designed system has been connected to a manipulator (even if it is
simulated) as an external agent and its control has been tuned for improved
performance.

\autoref{fig:simulator-scene} shows the manipulator model in a simulator scene
prepared to execute the \emph{pick and place} task with a simulated stick.
\autoref{fig:simulator-pick-and-place} illustrates how the task is performed in
the simulator. Additionally one can reproduce this task in the simulator by
opening the
\href{https://gitlab.com/jemaro/wut/group-project-a/-/blob/master/coppeliasim/robot_pick_and_place.ttt}{robot\_pick\_and\_place.ttt}
scene in CoppeliaSim EDU and executing the following command in \texttt{matlab}
while positioned in the root of the
\href{https://gitlab.com/jemaro/wut/group-project-a}{repository}:

\begin{lstlisting}[language=matlab,label=test-kinematics]
    run_tests 'pick_and_place'
\end{lstlisting}

\begin{figure}[h!]
    \centering
    \includegraphics[width=.8\textwidth]{\subdir/scene.png}
    \caption{CoppeliaSim EDU scene \texttt{robot\_pick\_and\_place.ttt}}
    \label{fig:simulator-scene}
\end{figure}

\begin{figure} [h!]
    \centering
    \includegraphics[width=.8\textwidth]{\subdir/pick_and_place.png}
    \caption{\emph{Pick and place} task in the simulator}
    \label{fig:simulator-pick-and-place}
\end{figure}

% \begin{tikzpicture}[node distance=8em,auto,
%     subsystem/.style={roundbox, text width=15em, align=center, inner sep=1em},
%     vio/.style={roundbox, fill=gray!5, text width=5em, align=center, inner sep=1em},
%     buffer/.style={roundbox,accepting} 
%     ]
%     %% Agent Robot
%     % Subsystems
%     \node (c) [subsystem] {$c_R$\\Control Subsystem};
%     \node (I) [subsystem, right=of c.east, anchor=west] 
%         {$s_I$\\Interface Subsystem};
%     % Efectors
%     \node (e_Rg) [vio,below=of c.south east,anchor=south east] 
%         {$e_{R,g}$\\Virtual\\Gripper};
%     \node (e_Rj) [vio,below=of c.south west,anchor=south west] 
%         {$e_{R,j}$\\Virtual\\Joints};

%     % Buffers
%     \node (c_cR) [buffer, anchor=west] at ([xshift=0.5em]c.mid west)
%         {$\leftidx{^c}{c}{_R}$};
%     \node (c_cR_desc) [right=of c_cR] {Internal Memory};
%     % \node (sx_c_RI) [buffer] at (c.east) {$\leftidx{^s_x}{c}{_{R,I}}$};
%     % \node (ey_c_Rj) [buffer] at (c.south -| e_Rg.north) 
%         % {$\leftidx{^e_y}{c}{_{R,j}}$};

%     \path 
%         (c.south -| e_Rg.north) edge [left, bend right] node
%             {close gripper} (e_Rg.north)
%         ;

%     % \path[->] 
%     %     (c.195) edge [left, bend right] node{0} (e.north)
%     %     (e.north) edge [right, bend right] node{1} (c.195)
%     %     (c.345) edge [left, bend right] node{0} (r.north)
%     %     (r.north) edge [right, bend right] node{1} (c.345)
%     %     ;

%     \begin{pgfonlayer}{background} 
%         \node (R) [back box] [fit=(c) (I) (e_Rj)] {};
%         \node (Rname) [roundbox, anchor=north west] at (R.north west) {$a_R$};
%         \node (Rdesc) [right of=Rname] {Robot};
%     \end{pgfonlayer}

%     \node (SIM) [back box, below=of e_Rj.south west, anchor=north west, 
%         text width=12em, align=center] {CoppeliaSim EDU};
%     \node (SIMname) [roundbox, anchor=north west] 
%         at (SIM.north west) {$a_{SIM}$};

%     \path 
%         (e_Rj.south) edge [left] node{0} (SIM.north -| e_Rj.south)
%         (e_Rg.south) edge [left] node{0} (SIM.north -| e_Rg.south)
%         ;
% \end{tikzpicture}

